void ButterflyGive (void *out, int len)
{
 MPI_Send(out, len, FrStack[Top]->context.b.ty, FrStack[Top]->context.b.mypartnerrank, 0, FrStack[Top]->mycomm);
}              

void *ButterflyTake (int *items)
{
 MPI_Status stat;
 void *takeptr;

 MPI_Probe(FrStack[Top]->context.b.mypartnerrank, 0, FrStack[Top]->mycomm, &stat); 
 MPI_Get_count(&stat, FrStack[Top]->context.b.ty, items);
 takeptr = (void *) malloc (*items * FrStack[Top]->context.b.itemsz);
 MPI_Recv(takeptr, *items, FrStack[Top]->context.b.ty, FrStack[Top]->context.b.mypartnerrank, 0, FrStack[Top]->mycomm, &stat); 
 return takeptr;  
}

void *ButterflyExchange (int *inlen, void *out, int outlen) 
{
   void *temp;

   if (FrStack[Top]->context.b.mypartnerrank > myrank()) {
     ButterflyGive(out, outlen);
     return ButterflyTake(inlen);
   } else {
     temp = ButterflyTake(inlen);
     ButterflyGive(out, outlen);
     return temp;
   }

}

