#include "../eSkel.c"

#define P 8
#define L 3      // number of levels, ie log2 8
#define THINGS 3

int *a;
int *b;

void level (void)
{
  int i, length = THINGS;

  b = Exchange(&length, a, THINGS);
  a = b;
}

int main (int argc, char *argv[])
{
  int i, p;

  MPI_Init(&argc, &argv);
  SkelLibInit();

  a = (int *) malloc (THINGS *sizeof(int));
  for (i=0; i<THINGS; i++) a[i] = myrank();
  for (p=0; p<P; p++) {
    if (myrank() == p) {
      printf("P%d starts with ",myrank());
      for (i=0; i<THINGS; i++) {
          printf("%d ", a[i]);
      }
      printf("\n");
    }
  }

  Butterfly (L, level, MPI_INT, mycomm());

  for (p=0; p<P; p++) {
    if (myrank() == p) {
      printf("P%d finishes with ",myrank());
      for (i=0; i<THINGS; i++) {
          printf("%d ", a[i]);
      }
      printf("\n");
    }
  }
  MPI_Finalize();
  return 0;
}
